<template>
    <div class="first-style-container">
        <div class="row">
            <div
                v-for="(offer, index) in popup.growth_offers"
                v-if="offer.status"
                :key="index"
                class="col-lg-4 col-sm-4 col-xs-4 gift-size-container"
            >
                <div
                    v-if="popup.growth_offers[0].optin_channel !== 'any' && offer.order != 1"
                    class="blur"
                >
                    <div v-if="popup.popup_background_type == 2" />
                    <div
                        v-else
                        class="blur"
                        :style="{backgroundColor: popup.colors.settings_background + 'cc'}"
                    />
                </div>
                <span v-if="popup.icon_style == 1">
                    <img
                        v-if="offer.order < 3"
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/gift1_opened.svg'"
                    >
                    <img
                        v-else
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/Gift1.svg'"
                    >
                </span>
                <span v-if="popup.icon_style == 2">
                    <img
                        v-if="offer.order < 3"
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/opened_sgift-2.svg'"
                    >
                    <img
                        v-else
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/gift_1.svg'"
                    >
                </span>
                <span v-if="popup.icon_style == 3">
                    <img
                        v-if="offer.order < 3"
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/gift3_opened.svg'"
                    >
                    <img
                        v-else
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/present-box-2.svg'"
                    >
                </span>
                <span v-if="popup.icon_style == 4">
                    <img
                        v-if="offer.order < 3"
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="popup.popup_image"
                    >
                    <img
                        v-else
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="popup.popup_image_closed"
                    >
                </span>
            </div>
        </div>
        <div
            v-if="activeOffers === 3"
            class="row justify-content-center mb-5"
        >
            <div
                class="col-md-4 col-sm-4 col-xs-4 line1"
                style="width: 33%"
                :style="{backgroundColor: popup.colors.progress_bar_color}"
            >
                <div
                    class="start-circle"
                    :style="{backgroundColor: popup.colors.progress_bar_color}"
                />
                <div
                    class="end-circle"
                    :style="{backgroundColor: popup.colors.progress_bar_color}"
                />
            </div>
            <div
                class="col-md-4 col-sm-4 col-xs-4 line2"
                style="width: 33%"
            >
                <div class="end-circle" />
            </div>
        </div>
        <div
            v-if="activeOffers === 2"
            class="row justify-content-center mb-5"
        >
            <div
                class="col-md-4 col-sm-4 col-xs-4 line1"
                :style="{backgroundColor: popup.colors.progress_bar_color}"
            >
                <div
                    class="start-circle"
                    :style="{backgroundColor: popup.colors.progress_bar_color}"
                />
                <div
                    class="end-circle"
                    :style="{backgroundColor: popup.colors.progress_bar_color}"
                />
            </div>
        </div>
        <div
            v-if="activeOffers === 1"
            class="row justify-content-center mb-5"
        >
            <div class="col-md-4 col-sm-4 col-xs-4">
                <div
                    class="last-circle"
                    :style="{backgroundColor: popup.colors.progress_bar_color}"
                />
            </div>
        </div>
        <div class="row discount-preview-container">
            <div
                v-for="offer in popup.growth_offers"
                v-if="offer.status"
                :style="{color: popup.colors.progress_bar_color}"
                :class="{'col-lg-12': deviceType === 0, 'col-md-4': deviceType === 1}"
                style="width: 33%"
            >
                {{ offer.automatic_discount_value }}%
            </div>
        </div>
        <hooper
            ref="carousel"
            class="hooper-container"
            :settings="hooperSettings"
            :center-mode="true"
            @slide="updateCarousel"
        >
            <slide
                v-for="offer in popup.growth_offers"
                v-if="offer.status"
                :key="offer.order"
                class="slide-container"
            >
                <div
                    v-if="popup.growth_offers[0].optin_channel !== 'any' && offer.order != 1"
                    class="blur"
                >
                    <div v-if="popup.popup_background_type == 2" />
                    <div
                        v-else
                        class="blur"
                        :style="{backgroundColor: popup.colors.settings_background + 'cc'}"
                    />
                </div>
                <div class="growth-cart-container">
                    <div class="full-width">
                        <div
                            :id="`growth-text-${offer.order-1}`"
                            :class="deviceType===1?'action-gift-container-preview':''"
                            :style="{backgroundColor: offer.background_color}"
                            class="action-gift-container"
                        >
                            <div
                                v-if="!showThank[offer.order - 1].active"
                                :style="{color: offer.text_color}"
                                class="title"
                            >
                                {{ replaceShortcodes(offer.offer_text, offer.automatic_discount_value) }}
                            </div>
                            <div
                                v-if="offerTypes[offer.order-1] === 'email'"
                                class="full-width"
                                :class="{'full-height': showThank[offer.order - 1].active}"
                            >
                                <div
                                    :class="{'full-height': showThank[offer.order - 1].active}"
                                    class="sms-phone-container"
                                >
                                    <div
                                        v-if="showThank[offer.order - 1].active"
                                        :id="`thank-text-${offer.order-1}`"
                                        class="thank-you-message-container"
                                    >
                                        <div
                                            v-html="replaceShortcodes(offer.thank_message, offer.automatic_discount_value, offer.order)"
                                        />
                                    </div>
                                    <div
                                        v-if="!showThank[offer.order - 1].active"
                                        class="growth-input-container"
                                    >
                                        <div
                                            class="growth-input-icon-container"
                                            :style="{backgroundColor:offer.icon_background_color}"
                                        >
                                            <IconEmail
                                                class="growth-action-icons"
                                                :color="offer.icon_color"
                                            />
                                        </div>
                                        <input
                                            name="password"
                                            :placeholder="offer.placeholder_text !== null ? offer.placeholder_text : 'Your email address'"
                                            class="email-input"
                                        >
                                    </div>
                                </div>
                                <div>
                                    <button
                                        v-if="!showThank[offer.order - 1].active"
                                        :style="{backgroundColor: offer.btn_color, color: offer.btn_text_color}"
                                        class="btn get-discount-btn-full"
                                    >
                                        {{ offer.btn_text }}
                                    </button>
                                </div>
                            </div>
                            <div
                                v-if="offerTypes[offer.order-1] === 'sms'"
                                class="full-width"
                                :class="{'full-height': showThank[offer.order - 1].active}"
                            >
                                <div
                                    :class="{'full-height': showThank[offer.order - 1].active}"
                                    class="sms-phone-container"
                                >
                                    <div
                                        v-if="showThank[offer.order - 1].active"
                                        :id="`thank-text-${offer.order-1}`"
                                        class="thank-you-message-container"
                                    >
                                        <div
                                            v-html="replaceShortcodes(offer.thank_message, offer.automatic_discount_value, order.offer)"
                                        />
                                    </div>
                                    <div
                                        v-if="!showThank[offer.order - 1].active"
                                        class="growth-input-container"
                                    >
                                        <div
                                            class="growth-input-icon-container"
                                            :style="{backgroundColor: offer.icon_background_color}"
                                        >
                                            <IconSms
                                                class="growth-action-icons"
                                                :color="offer.icon_color"
                                            />      
                                        </div>
                                        <input
                                            type="number"
                                            name="password"
                                            :placeholder="offer.placeholder_text !== null ? offer.placeholder_text : 'Your phone number'"
                                            class="email-input"
                                        >
                                    </div>
                                </div>
                                <div>
                                    <button
                                        v-if="!showThank[offer.order - 1].active"
                                        :style="{backgroundColor: offer.btn_color, color: offer.btn_text_color}"
                                        class="btn get-discount-btn-full"
                                    >
                                        {{ offer.btn_text }}
                                    </button>
                                </div>
                            </div>
                            <div
                                v-if="offerTypes[offer.order-1] === 'push'"
                                class="full-width"
                                :class="{'full-height': showThank[offer.order - 1].active}"
                            >
                                <div
                                    :class="{'full-height': showThank[offer.order - 1].active}"
                                    class="sms-phone-container"
                                >
                                    <div
                                        v-if="showThank[offer.order - 1].active"
                                        :id="`thank-text-${offer.order-1}`"
                                        class="thank-you-message-container"
                                    >
                                        <div
                                            v-html="replaceShortcodes(offer.thank_message, offer.automatic_discount_value, order.offer)"
                                        />
                                    </div>
                                    <div
                                        v-if="!showThank[offer.order - 1].active"
                                        class="growth-input-container"
                                    >
                                        <div
                                            class="growth-input-icon-container"
                                            :style="{backgroundColor:offer.icon_background_color}"
                                        >
                                            <IconPush
                                                class="growth-action-icons"
                                                :color="offer.icon_color"
                                            />
                                        </div>
                                        <div
                                            id="growth-push-text"
                                            class="push-text"
                                        >
                                            {{ offer.placeholder_text !== null ? offer.placeholder_text : 'Push notification' }}
                                        </div>
                                    </div>
                                </div>
                                <div>
                                    <button
                                        v-if="!showThank[offer.order - 1].active"
                                        :style="{backgroundColor: offer.btn_color, color: offer.btn_text_color}"
                                        class="btn get-discount-btn-full"
                                    >
                                        {{ offer.btn_text }}
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </slide>
        </hooper>
        <div>
            <a
                class="nav-btn-prev"
                :style="{backgroundColor: popup.colors.arrow_color}"
                @click.prevent="slidePrev"
            >
                <svg
                    xmlns="http://www.w3.org/2000/svg"
                    width="10"
                    height="10"
                    viewBox="0 0 9.414 16.828"
                >
                    <path
                        id="chevron-down"
                        d="M0,0,7,7l7-7"
                        transform="translate(8 1.414) rotate(90)"
                        fill="none"
                        stroke="#fff"
                        stroke-linecap="round"
                        :class="{'grey-stroke': carouselData === 0}"
                        stroke-linejoin="round"
                        stroke-width="2"
                    />
                </svg>
            </a>
            <a
                class="nav-btn-next"
                :style="{backgroundColor: popup.colors.arrow_color}"
                @click.prevent="slideNext"
            >
                <svg
                    xmlns="http://www.w3.org/2000/svg"
                    width="10"
                    height="10"
                    viewBox="0 0 9.414 16.828"
                >
                    <path
                        id="chevron-down"
                        d="M6,16l7-7,7,7"
                        transform="translate(17.414 -4.586) rotate(90)"
                        fill="none"
                        stroke="#fff"
                        stroke-linecap="round"
                        :class="{'grey-stroke': carouselData === 2
                        }"
                        stroke-linejoin="round"
                        stroke-width="2"
                    />
                </svg>
            </a>
        </div>
    </div>
</template>

<script>

import IconPush from '@/components/growth-tools/new/icons/Push.vue'
import IconSms from '@/components/growth-tools/new/icons/Sms.vue'
import IconEmail from '@/components/growth-tools/new/icons/Email.vue'
import {Hooper, Navigation as HooperNavigation, Slide} from "hooper";
import 'hooper/dist/hooper.css';

export default {
    name: 'StyleFirstMobile',
     components: {
        IconPush,
        IconEmail,
        IconSms,
        Hooper, 
        Slide, 
        HooperNavigation
    },
    props: ['popup', 'deviceType', 'showThank', 'activeOffers'],
    data() {
        return {
            carouselData: 0,
            offerTypes: [],
            activeCount: 0,
            code: Math.random().toString(36).slice(2, 8).toUpperCase(),
            hooperSettings: {
                itemsToShow: 1,
            },
            anyType: '',
        }
    },
    computed: {
        isEmail() {
            return this.carouselData === 0
        },
        isSms() {
            return this.carouselData === 1
        },
        // isMessenger() {
        //   return this.carouselData === 2
        // },
        isPush() {
            return this.carouselData === 2
        }
    },
    watch: {
        carouselData() {
            this.$refs.carousel.slideTo(this.carouselData);
        },
        popup: {
            deep: true,
            handler() {
                this.offerTypes = [];
                this.popup.growth_offers.map(offer => {
                    this.offerTypes.push(offer.optin_channel);
                });
                this.getTypeFromAny();
            }
        },
    },
    mounted() {
        this.offerTypes = [];
        this.popup.growth_offers.map(offer => {
            this.offerTypes.push(offer.optin_channel);
        });
        this.getTypeFromAny();
    },
    methods: {
        slidePrev() {
            this.$refs.carousel.slidePrev();
        },
        slideNext() {
            this.$refs.carousel.slideNext();
        },
        updateCarousel(payload) {
            this.carouselData = payload.currentSlide;
        },
        replaceShortcodes(text, value = '', order = 1) {
            if (text) {
                text = text.replace(/{discountValue}/g, value);
                const currentOffer = this.popup.growth_offers[order-1]
                const thankCode = currentOffer.automatic_discount_enabled == 1 ? this.code : currentOffer.code
                text = text.replace(/{discountCode}/g, `<span class="preview-thank-code">${thankCode || 'enter code'}</span>`);
            }
            return text;
        },
        getTypeFromAny() {
            const allValues = ["email", "sms", "push"];
            let difference = allValues.filter(x => this.offerTypes.indexOf(x) == -1);
            let k = 0;
            for (let i = 0; i < 4; i++) {
                if (this.offerTypes[i] === 'any') {
                    this.offerTypes[i] = difference[k];
                    k++;
                }
            }
        },
    }
}
</script>

<style scoped lang="scss">

.mb-5 {
    margin-bottom: 5px !important;
}

.discount-preview-container {
    font-size: 12px;
    font-weight: bold;
    margin: 0 !important;
}

.full-height {
    height: 100%;
    margin: 0 !important;
    min-height: 100% !important;
}

.mobile-gift-size-1 {
    height: 30px;
}

.mobile-gift-size-2 {
    height: 40px;
}

.mobile-gift-size-3 {
    height: 50px;
}

.thank-you-message-container {
    height: 100%;
    width: 100%;
    display: flex;
    flex-direction: column;
    justify-content: space-between;

    div {
        display: flex;
        height: 100%;
        flex-direction: column;
        justify-content: center;
    }
}


.last-circle {
    width: 10px;
    height: 10px;
    border-radius: 50%;
    position: absolute;
    top: -4.5px;
    left: calc(50% - 5px);
}

.blur {
    position: absolute;
    height: inherit;
    width: inherit;
    cursor: not-allowed;
    z-index: 2;
}

.page-container {
    background-color: #707070;
    padding: 70px 0px;
}

.is-prev {
    .gift-img {
        fill: rgba(71, 134, 255, 0.4);
    }
}

.growth-cart-container {
    margin-bottom: 20px;
    width: 50%;
}

input::-webkit-outer-spin-button,
input::-webkit-inner-spin-button {
    -webkit-appearance: none;
    margin: 0;
}

input[type=number] {
    -moz-appearance: textfield;
}

.progress-count {
    color: #98A0A6;
    font-weight: 500;
    position: absolute;
    left: 30px;
    top: 30px;

    span {
        color: #4786FF;
    }
}

.growth-input-container {
    display: flex;
    align-items: center;
}


.get-discount-btn-full {
    color: #98A0A6;
    padding: 4px;
    background: #DEE1E6;
    border-radius: 5px;
    text-align: center;
    font-size: 11px;
    margin-top: 7px;
    width: 100%;
    min-width: 95px;
}

.growth-cart-container {
    width: 80% !important;
}

.messenger-container2 {
    display: flex;
    font-size: 8px;
    align-items: center;
    color: #98A0A6;
    font-weight: 300;
    margin-top: 5px;

    img {
        margin-right: 2px;
    }

    a {
        font-weight: 500;
        margin-left: 2px;
        color: #98A0A6;
    }
}

.phone-number {
    font-size: 8px;
    text-align: left;
    margin-bottom: -5px;
}

.sms-phone-container {
    display: flex;
    min-width: 100px;
    flex-direction: column;
    margin-top: 7px;
    align-items: center;
}

.facebook-check {
    font-size: 8px;
    width: 42px;
    display: flex;
}

.input-img-container {
    position: relative;
}

.gift-container {
    display: grid;
    align-items: end;
    height: 205px;
    @media screen and (max-width: 1200px) {
        height: auto;
        margin-top: 20px;
    }
}

.growth-action-icons {
    width: 21px;
}

.action-gift-container {
    min-height: 136px;
    justify-content: center;
    align-items: center;
    @media screen and (max-width: 1200px) {
        justify-content: center;
        height: auto;
    }
}

.action-gift-container-preview {
    justify-content: flex-end;
    height: 100%;

}

.usa-icon {
    position: absolute;
    top: 9px;
    left: 2px;
}

.arrow-down {
    position: absolute;
    top: 12px;
    left: 12px;
}

.gift-input-container {
    position: relative;
    padding-right: 17px;
    min-width: 100px;
    margin-top: 7px;
    @media screen and (max-width: 1200px) {
        min-width: 120px;
    }
}

.gift-input-container-preview {
    min-width: 120px;
}

.mt-20 {
    margin-top: 55px;
    position: relative;
}

.phone-input-container {
    margin-left: 5px;
}

.messenger-container {
    display: flex;
    font-size: 8px;
    align-items: center;

    img {
        margin-right: 2px;
    }
}

.nav-button-container {
    margin-top: 20px;
    display: flex;
    justify-content: center;
    align-items: baseline;
}

.grey-stroke {
    stroke: #D7D9DB;
}

.blue-fill {
    fill: #4786FF !important;
}

.blue-stroke {
    stroke: #4786FF !important;
}

.bottom-line {
    background-color: #4786FF;
    height: 2px;
    width: 100%;
    display: none;
}

.bottom-line-active {
    display: block !important;
    fill: #4786FF;
}

.email-tab-icon {
    stroke: #D7D9DB;
}

.icon-container {
    padding: 5px 5px 0 5px;

    svg {
        margin-bottom: 10px;
    }
}

.nav-button {
    margin-bottom: 10px;
    cursor: pointer;
}

.nav-btn-prev {
    position: absolute;
    bottom: 20%;
    left: 5% !important;
    cursor: pointer;
    width: 22px;
    height: 22px;
    align-items: center;
    display: flex;
    border-radius: 60%;
    justify-content: center;
}

.gift-input-container {
    position: relative;
    padding-right: 17px;
    min-width: 120px;
    margin-top: 7px;
}

.email-input {
    height: 27px;
    border: 1px solid #DAE7FF;
    border-radius: 5px;
    font-size: 10px;
}

.get-discount-btn {
    color: #98A0A6;
    position: absolute;
    right: 0;
    bottom: 0;
    padding: 3px;
    background: #DEE1E6;
    border-radius: 5px;
    text-align: center;
    font-size: 7px;
}

.hooper:focus {
    outline: none
}

.nav-btn-next {
    cursor: pointer;
    position: absolute;
    bottom: 20%;
    right: 5% !important;
    width: 22px;
    height: 22px;
    align-items: center;
    display: flex;
    border-radius: 60%;
    justify-content: center;
}

.is-next {
    .gift-img {
        fill: rgba(71, 134, 255, 0.4);
    }
}

.gift-img {
    fill: #4786FF;
}


.slide-container {
    background: none;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
}

.preview-container {
    display: flex;
    padding-top: 30px;
    background-color: white;
    margin-left: auto;
    margin-right: auto;
    max-width: 420px;
    justify-content: center;
    flex-direction: column;
    align-items: center;

}

.timer-style-1 {
    color: #707070;
    margin-top: 30px;
    margin-bottom: 30px;
    font-weight: 500;
}

.timer-number-style-1 {
    padding: 5px;
    background-color: #F5F6FA;
    border-radius: 5px;
    margin-right: 5px;
}

.timer-space-style-1 {
    margin: 0 5px;
}

input::-webkit-outer-spin-button,
input::-webkit-inner-spin-button {
    -webkit-appearance: none;
    margin: 0;
}

.start-circle {
    width: 10px;
    height: 10px;
    border-radius: 50%;
    position: absolute;
    top: -4.5px;
    left: -5px;
}

.end-circle {
    width: 10px;
    height: 10px;
    border-radius: 50%;
    z-index: 10;
    position: absolute;
    top: -4.5px;
    right: -5px;
    background-color: #E5E5E5;
}

.line1 {
    height: 2px;
}

.line2 {
    height: 2px;
    background-color: #E5E5E5;
}

input[type=number] {
    -moz-appearance: textfield;
}

.push-text {
    font-size: 12px;
    width: max-content;
    text-align: initial;
    padding: 0 7.5px;
}

.gift-size-container {
    display: flex;
    justify-content: center;
    align-items: flex-end;
    height: 50px;
}


.growth-action-icons {
    width: 15px;
}

.first-style-container {
    display: flex;
    flex-direction: column;
}

.title {
    font-size: 14px;
    font-weight: 500;
    margin-bottom: 10px;
}

.growth-input-container {
    display: flex;
    align-items: center;
    width: 100%;
}

.blur {
    position: absolute;
    height: inherit;
    width: 100%;
    cursor: not-allowed;
    z-index: 2;
}

.items-center {
    flex-direction: initial;
    display: flex;
    justify-content: center;
    @media screen and (max-width: 1200px) {
        flex-direction: column;
    }
}


</style>
